"use strict";
const index_1 = require("../../index");
const RelationTypes_1 = require("../../metadata/types/RelationTypes");
/**
 * Marks a specific property of the class as a parent of the tree.
 */
function TreeParent(options) {
    return function (object, propertyName) {
        if (!options)
            options = {};
        const reflectedType = Reflect.getMetadata("design:type", object, propertyName);
        const args = {
            isTreeParent: true,
            target: object.constructor,
            propertyName: propertyName,
            propertyType: reflectedType,
            relationType: RelationTypes_1.RelationTypes.MANY_TO_ONE,
            type: () => object.constructor,
            options: options
        };
        index_1.getMetadataArgsStorage().relations.add(args);
    };
}
exports.TreeParent = TreeParent;
//# sourceMappingURL=TreeParent.js.map